from subprocess import call
import usb
import pygtk
pygtk.require('2.0')
import pynotify
import sys
import time

VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH1 = 1    #sw1
VENDOR_RQ_GET_SWITCH2 = 2    #sw2
VENDOR_RQ_GET_SWITCH3 = 3    #sw3

def setL(m):       #set LED select by mode 1-3
	if m == 1:
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 0))
			handle.controlMsg(req, 0, None, value=(((16**2)*0) + 1))
			handle.controlMsg(req, 0, None, value=(((16**2)*0) + 2))
	elif m ==2:
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 0))
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 1))
			handle.controlMsg(req, 0, None, value=(((16**2)*0) + 2))
	elif m ==3:
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 0))
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 1))
			handle.controlMsg(req, 0, None, value=(((16**2)*1) + 2))		

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev
    return None

def notify(message):
    n.update("Music player",message)
    n.set_timeout(pynotify.EXPIRES_DEFAULT)
    n.show()


board = find_board()
handle = board.open()
mode=1
cm=0
count=0
a=1
first = 1
print "Program start"

if not pynotify.init("Start"):
    sys.exit(1)
n = pynotify.Notification("Project", "Start Program")
n.set_timeout(0)

while a!=0 :
	if cm > 100 :             #mode reset control
		mode = 1
		setL(mode)
		cm=0
	cm=cm+1

	req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
	x = handle.controlMsg(req, 1, 1)
	req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
	y = handle.controlMsg(req, 2, 2)
	req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
	z = handle.controlMsg(req, 3, 3)	




	if(x == (1,)):
		cm=0
		count=0
		while x==(1,) :       # pushing down
			req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
			x = handle.controlMsg(req, 1, 1)
			if mode == 2 :
				count=count+1
				if count % 10 == 0 :
					msg = call(['rhythmbox-client','--volume-down'])
					notify(str("Volume down"))
#    push up
		
		if mode == 1 :
			
			call(['rhythmbox-client','--previous'])
			call(['rhythmbox-client','--notify'])
			count=0
		elif mode ==2 :
			msg = call(['rhythmbox-client','--volume-down'])

			notify(str("Volume down"))	

	if(y == (1,)):
		cm=0
		count=0
		while y==(1,) :  # pushing down
			req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
			y = handle.controlMsg(req, 2, 2)

			count=count+1			
			if mode == 1:				
				if count>100 :
					mode = 2
					setL(mode)
					cm=0
					print "mode2"
			elif mode == 2:
				if count >500 :
					cm=0
					call(['rhythmbox-client','--quit'])
					setL(3)
					print "Exit Rhythmbox"
					a=0
					setL(1)
#    push up		

		if mode == 1:
			msg = call(['rhythmbox-client','--play-pause'])
			msg = call(['rhythmbox-client','--notify'])
		elif mode ==2:
			if count == 0 :
				mode =1
				setL(mode)



	if(z == (1,)):
		cm=0
		count=0
		while z==(1,) :  # pushing down
			req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
			z = handle.controlMsg(req, 3, 3)
			if mode == 2 :
				count=count+1
				if count % 10 == 0 :
					msg = call(['rhythmbox-client','--volume-up'])
					notify(str("Volume up"))
#    push up
		if mode == 1 :
			call(['rhythmbox-client','--next'])
			call(['rhythmbox-client','--notify'])
			count=0
		elif mode ==2 :
			msg = call(['rhythmbox-client','--volume-up'])
			notify(str("Volume up"))
			if cm > 1000 :
				mode =1
				req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
				handle.controlMsg(req, 0, None, value=(((16**2)*1) + 0))
				handle.controlMsg(req, 0, None, value=(((16**2)*0) + 1))
				cm=0

